<template>
  <div class="UserManagement">
    <b-container>
      <b-row align-h="between">
        <b-col sm="10" align-self="start">
          <div class="adaptAlign">
            <b-row>
              <b-col sm="5" @keydown.enter.prevent.self="" id="firstCol">
                <v-select
                  v-model="selectedObject"
                  :placeholder="$t('searchUserPlaceholder')"
                  :class="{
                    adaptSelect: true,
                    'no-results': queriedUsers.length === 0,
                  }"
                  :options="queriedUsers"
                  :filterBy="filterMock"
                  @change="validateSelection"
                  @input="setNewUser"
                  @search="triggerFetchOptions"
                  :selectable="(option) => !option.hasProjectRole"
                >
                  <template v-if="searchString == ''" slot="no-options">
                    {{ $t("pleaseTypeSomething") }}
                  </template>
                  <template v-else-if="validateEmail()" slot="no-options">
                    {{ $t("searchEmailInvite") }}
                  </template>
                  <template
                    v-else-if="searchString.length < 3"
                    slot="no-options"
                  >
                    {{ $t("searchNotEnoughCharacters") }}
                  </template>
                  <template v-else slot="no-options">
                    {{ $t("noUserOptions") }}
                  </template>
                  <template slot="option" slot-scope="option">
                    <div class="d-center">
                      <span v-if="validateEmail()">
                        {{
                          $t("inviteUserCaption1") +
                          option.displayName +
                          $t("inviteUserCaption2")
                        }}
                      </span>
                      <span v-else>
                        {{ option.displayName }}
                      </span>
                      <span v-if="option.hasProjectRole">{{
                        $t("alreadyGotRole")
                      }}</span>
                    </div>
                  </template>
                  <template slot="selected-option" slot-scope="option">
                    <div class="selected d-center">
                      {{ option.displayName }}
                    </div>
                  </template>
                </v-select>
              </b-col>
              <b-col sm="2" id="secondCol">
                <b-form-select
                  v-model="newUserRole.role.id"
                  :options="roles"
                  @change="validateSelection"
                  @input="setNewRole"
                >
                </b-form-select>
              </b-col>
              <b-col sm="5" id="thirdCol">
                <b-button
                  v-if="invitationIsValid && !selectionIsValid"
                  name="inviteUserToProject"
                  v-on:click="prepareInvitation(newUserRole)"
                  :disabled="!invitationIsValid"
                  >{{ $t("invite") }}</b-button
                >
                <b-button
                  v-else
                  name="addUserToProject"
                  v-on:click="addUser(newUserRole)"
                  :disabled="!selectionIsValid"
                  >{{ $t("addUser") }}</b-button
                >
                <b-button
                  name="importUser"
                  v-on:click="$bvModal.show('importUserModal')"
                  >{{ $t("importUserButton") }}</b-button
                >
              </b-col>
            </b-row>
          </div>
        </b-col>
        <b-col
          sm="2"
          align-self="end"
          @keydown.enter.prevent.self=""
          id="forthCol"
        >
          <b-input-group>
            <b-form-input
              v-model="filter"
              type="search"
              id="filterInput"
              :placeholder="$t('typeToSearch')"
            ></b-form-input>
          </b-input-group>
        </b-col>
      </b-row>
      <br />
      <b-row>
        <b-col>
          <b-tabs content-class="mt-2">
            <b-tab :title="$t('membersTabTitle')">
              <members-table
                id="userTable"
                :headers="memberHeaders"
                :items="projectRoles"
                :filter="filter"
                :busy="isBusy"
                :roles="roles"
                :emptyText="$t('emptyTableText')"
                :emptyFilteredText="$t('emptyFilterText')"
                :removeText="$t('delete')"
                @tableFilteredRows="onFilteredRows"
                @setRole="setRole"
                @selectedItem="prepareDeletion"
              >
              </members-table>
            </b-tab>
            <b-tab :title="$t('externalUsersTabTitle')">
              <members-table
                id="invitationTable"
                :headers="invitationHeaders"
                :items="externalUsers"
                :filter="filter"
                :busy="isBusy"
                :roles="roles"
                :emptyText="$t('emptyTableText')"
                :emptyFilteredText="$t('emptyFilterText')"
                :removeText="$t('delete')"
                sort-by="email"
                @revokeInvitation="revokeInvitation"
                @resendInvitation="resendInvitation"
              >
              </members-table>
            </b-tab>
          </b-tabs>
        </b-col>
      </b-row>
    </b-container>
    <!-- modal for revoke Invited email  -->
    <delete-modal
      descriptionKey="removeSelectedInvitation"
      titleKey="deleteInvitationTitle"
      :visible="isDeleteInvitedUserModalVisible"
      :selectedUser="selectedInvitation.email"
      :selectedProject="projectName"
      @ok="confirmRevokeInvitation"
      @close="closeInvitedUserModal"
    >
    </delete-modal>
    <!--- end of modal for revoke Invited email --->
    <!--- Modal for delete current members --->
    <delete-modal
      :visible="isDeleteUserModalVisible"
      :selectedUser="candidateForDeletion.user.displayName"
      :selectedProject="projectName"
      @ok="deleteUser"
      @close="closeUserModal"
    >
    </delete-modal>
    <!--- end of modal for delete members --->
    <b-modal
      id="invitationPendingModal"
      :title="$t('inviteUserTitle')"
      @hidden="resetModal()"
      :hide-footer="true"
    >
      <ul>
        <li>
          <i18n path="invitationPendingText1">
            <template #emailAddress>
              <strong>{{ candidateForInvitation.user.emailAddress }}</strong>
            </template>
          </i18n>
        </li>
        <li>
          {{ $t("invitationPendingText2") }}
        </li>
      </ul>
      <br />
      <b-button @click="$bvModal.hide('invitationPendingModal')">{{
        $t("cancel")
      }}</b-button>
    </b-modal>
    <b-modal
      id="inviteUserModal"
      :title="$t('inviteUserTitle')"
      @hidden="resetModal()"
      :hide-footer="true"
    >
      <div v-if="selectedObject != null && !isUserInvited">
        <i18n path="inviteUserText">
          <template #emailAddress>
            <strong>{{ candidateForInvitation.user.emailAddress }}</strong>
          </template>
          <template #role>
            <strong>{{ candidateForInvitation.role.displayName }}</strong>
          </template>
          <template #projectName>
            <strong>{{ projectName }}</strong>
          </template>
        </i18n>
      </div>
      <div v-else-if="selectedObject != null && isUserInvited">
        {{ $t("existingEmailInvitation.msg1") }}
        <strong>{{ candidateForInvitation.user.emailAddress }}</strong>
        {{ $t("existingEmailInvitation.msg2") }}
      </div>
      <br />
      <div>
        <b-button
          class="inviteModalRightBtn"
          variant="primary"
          @click="inviteUser()"
        >
          {{ !isUserInvited ? $t("inviteUser") : $t("reInviteUser") }}
        </b-button>
        <b-button
          class="inviteModalLeftBtn"
          variant="secondary"
          @click="$bvModal.hide('inviteUserModal')"
        >
          {{ $t("cancel") }}
        </b-button>
      </div>
    </b-modal>
    <b-modal
      id="importUserModal"
      :title="$t('importUserTitle')"
      @hidden="resetModal()"
      size="lg"
      hide-footer
    >
      <b-row>
        <b-col md="4" align-self="start">
          <b-form-select v-model="selectedProject" @change="setNewRoles">
            <template v-slot:first>
              <b-form-select-option :value="null" disabled>{{
                $t("searchProjectPlaceholder")
              }}</b-form-select-option>
            </template>
            <b-form-select-option
              v-for="project in additionalProjects"
              :value="project.id"
              :key="project.id"
            >
              {{ project.projectName }}
            </b-form-select-option>
          </b-form-select>
        </b-col>
      </b-row>
      <br />
      <b-row>
        <b-col>
          <div class="modalTable">
            <members-table
              id="projectRolesTable"
              :headers="memberHeaders"
              :items="additionalMembers"
              :filter="filter"
              :busy="isBusy"
              :roles="roles"
              :emptyText="$t('emptyImportTableText')"
              :emptyFilteredText="$t('emptyImportTableFilterText')"
              :removeText="$t('removeUser')"
              @tableFilteredRows="onFilteredRows"
              @selectedItem="removeSelectedRow"
            >
            </members-table>
          </div>
        </b-col>
      </b-row>
      <br />
      <b-row>
        <b-col>
          <div align="right">
            <b-button
              name="importUsers"
              v-on:click="importUser"
              :disabled="additionalMembers.length === 0"
              >{{ $t("importUserButton") }}</b-button
            >
          </div>
        </b-col>
      </b-row>
      <br />
    </b-modal>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import {
  RoleApi,
  UserApi,
  ProjectRoleApi,
  ProjectApi,
} from "@coscine/api-connection";
import { LanguageUtil } from "@coscine/app-util";
import vSelect from "vue-select";
import "vue-select/dist/vue-select.css";
import { ToastPlugin } from "bootstrap-vue";
import MembersTable from "./MembersTable.vue";
import DeleteModal from "./DeleteModal.vue";
Vue.use(ToastPlugin);

Vue.component("v-select", vSelect as any);

import Invitation from "@/types/invitation";

export default Vue.extend({
  name: "UserManagement",
  components: {
    MembersTable,
    DeleteModal,
  },
  created() {
    this.getInvitedUser();
    ProjectApi.getProjectInformation(this.parentId, (response: any) => {
      this.projectName = response.data.displayName;
    });
  },
  mounted() {
    RoleApi.getRoles((response: any) => {
      for (const datum of response.data) {
        this.roles.push({ value: datum.id, text: datum.displayName });
        if (datum.displayName === "Member") {
          this.roleDefaultId = datum.id;
          this.newUserRole.role.id = this.roleDefaultId;
          this.newUserRole.role.displayName = this.getRoleNameFromId(
            this.newUserRole.role.id
          );
        }
      }
    });
    this.getProjectRoles();
    ProjectApi.getProjects((response: any) => {
      for (const datum of response.data) {
        if (datum.id !== this.parentId) {
          this.additionalProjects.push(datum);
        }
      }
    });
  },
  data() {
    return {
      //---for controlling delete modals ---
      isDeleteInvitedUserModalVisible: false,
      isDeleteUserModalVisible: false,
      //--------------------------------------
      isUserInvited: false,
      //---for external users ---
      selectedInvitation: { id: "", email: "" },
      isRevokeInvitationModalVisible: false,
      isInvitationExpired: false,
      externalUsers: [] as Invitation[],
      //-------------------
      selectedProject: null as string | null,
      sortBy: "lastName",
      sortDesc: false,
      memberHeaders: [
        {
          label: this.$t("firstName"),
          key: "firstName",
          sortable: true,
        },
        {
          label: this.$t("lastName"),
          key: "lastName",
          sortable: true,
        },
        {
          label: this.$t("email"),
          key: "emailAddress",
          sortable: true,
        },
        {
          label: this.$t("role"),
          key: "roleName",
          sortable: true,
        },
        {
          label: this.$t("actions"),
          key: "memberActions",
          sortable: true,
        },
      ],
      invitationHeaders: [
        {
          label: this.$t("email"),
          key: "userMail",
          sortable: true,
        },
        {
          label: this.$t("role"),
          key: "role",
          sortable: true,
        },
        {
          label: this.$t("status"),
          key: "expiration",
          sortable: true,
        },
        {
          label: this.$t("actions"),
          key: "invitationActions",
          sortable: true,
        },
      ],
      additionalProjects: [] as Record<string, unknown>[],
      additionalMembers: [] as Record<string, unknown>[],
      isBusy: true,
      filteredRows: 0,
      filter: "",
      roleDefaultId: "",
      roles: [] as Record<string, unknown>[],
      projectRoles: [] as Record<string, unknown>[],
      newUserRole: {
        projectId: "",
        user: {
          id: "",
          displayName: "",
          givenname: "",
          surname: "",
          emailAddress: "",
        },
        role: {
          id: null as string | null,
          displayName: "",
        },
      },
      queriedUsers: [] as Record<string, unknown>[],
      queryTimer: 0,
      searchString: "",
      selectedObject: null as Record<string, unknown> | null,
      invitationIsValid: false,
      selectionIsValid: false,
      ownerCount: 0,
      projectName: "",
      candidateForDeletion: {
        projectId: "",
        user: {
          id: "",
          displayName: "",
          givenname: "",
          surname: "",
          emailAddress: "",
        },
        role: {
          id: null as string | null,
          displayName: "",
        },
      },
      candidateForInvitation: {
        projectId: "",
        user: {
          id: "",
          displayName: "",
          givenname: "",
          surname: "",
          emailAddress: "",
        },
        role: {
          id: null as string | null,
          displayName: "",
        },
      },
      regexExpression:
        /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,24}))$/,
    };
  },
  props: {
    parentId: String, // This is the current Project ID GUID
  },
  computed: {},
  methods: {
    //---for external users----
    storeNewInvitation(value: any, toastText: string, errorText: string) {
      ProjectApi.storeInvitation(
        value,
        () => {
          this.getInvitedUser();
          this.makeToast(toastText, this.$t("userManagement").toString());
        },
        () => {
          this.makeToast(
            errorText,
            this.$t("userManagement").toString(),
            "danger"
          );
        }
      );
    },
    getInvitedUser() {
      ProjectApi.getInvitationsList(this.parentId, (response: any) => {
        this.externalUsers = [];
        for (const data of response.data as Invitation[]) {
          this.externalUsers.push({
            userMail: data.userMail,
            roleId: data.roleId,
            role: this.getRoleNameFromId(data.roleId),
            expiration: data.expiration,
            id: data.id,
            issuer: data.issuer,
            projectId: data.projectId,
          });
        }
        this.isBusy = false;
      });
    },
    resendInvitation(selectedInvitation: Invitation) {
      const invitation = {
        projectId: selectedInvitation.projectId,
        role: selectedInvitation.roleId,
        email: selectedInvitation.userMail,
      };
      const errorText =
        this.$t("invitedUserError1") +
        selectedInvitation.userMail +
        this.$t("invitedUserError2");
      const text = this.$t("invitedUserText", {
        email: selectedInvitation.userMail,
        role: selectedInvitation.role,
        projectName: this.projectName,
      }).toString();
      this.storeNewInvitation(invitation, text, errorText);
    },
    revokeInvitation(selectedInvitation: Invitation) {
      this.selectedInvitation.id = selectedInvitation.id;
      this.selectedInvitation.email = selectedInvitation.userMail;
      this.isDeleteInvitedUserModalVisible = true;
    },
    confirmRevokeInvitation() {
      const text =
        this.$t("removedUser1") +
        this.selectedInvitation.email +
        this.$t("removedUser2") +
        this.projectName +
        this.$t("removedUser3");
      ProjectApi.deleteInvitation(
        this.selectedInvitation.id,
        () => {
          this.getInvitedUser();
          this.makeToast(text, this.$t("userManagement").toString());
        },
        () => {
          const errorMsg =
            this.$t("deleteExternalUserError1") +
            this.selectedInvitation.email +
            this.$t("deleteExternalUserError2");

          this.makeToast(
            errorMsg,
            this.$t("userManagement").toString(),
            "danger"
          );
        }
      );
      this.isDeleteInvitedUserModalVisible = false;
    },
    closeInvitedUserModal() {
      this.isDeleteInvitedUserModalVisible = false;
    },
    validateSelection() {
      const tempBoolValue =
        this.newUserRole.user !== undefined &&
        this.newUserRole.user !== null &&
        this.newUserRole.role !== undefined &&
        this.newUserRole.role !== null &&
        this.newUserRole.role.id !== undefined &&
        this.newUserRole.role.id !== null &&
        this.newUserRole.role.id !== "";
      if (this.validateEmail()) {
        this.invitationIsValid =
          tempBoolValue &&
          // For a non existing user, the is not presnet. The email could not be null.
          this.newUserRole.user.emailAddress !== undefined &&
          this.newUserRole.user.emailAddress !== "";
        this.selectionIsValid = false;
      } else {
        this.selectionIsValid =
          tempBoolValue &&
          // For an existing user, the ID is important. The email could be null.
          this.newUserRole.user.id !== undefined &&
          this.newUserRole.user.id !== "";
        this.invitationIsValid = false;
      }
    },
    validateEmail() {
      if (
        this.regexExpression.test(this.searchString) ||
        (this.selectedObject != null &&
          this.regexExpression.test((this.selectedObject as any).emailAddress))
      ) {
        return true;
      } else {
        return false;
      }
    },
    setNewUser(value: any) {
      this.newUserRole.user = value;
      this.newUserRole.projectId = this.parentId;
      this.validateSelection();
    },
    setNewRole(value: string) {
      this.newUserRole.role.id = value;
      this.newUserRole.role.displayName = this.getRoleNameFromId(
        this.newUserRole.role.id
      );
      this.validateSelection();
    },
    resetModal() {
      this.selectedProject = null;
      this.additionalMembers = [];
    },
    setNewRoles(value: any) {
      ProjectRoleApi.getProjectRoles(value, (response: any) => {
        this.additionalMembers = [];
        for (const datum of response.data) {
          const found = this.projectRoles.some(
            (el) => (el as any).displayName === datum.user.displayName
          );
          if (!found) {
            datum.firstName = datum.user.givenname;
            datum.lastName = datum.user.surname;
            datum.displayName = datum.user.displayName;
            datum.emailAddress = datum.user.emailAddress;
            datum.roleName = "Member";
            datum.role.id = this.roleDefaultId;
            datum.enabledControls = true;
            this.additionalMembers.push(datum);
          }
        }
        this.isBusy = false;
        this.filteredRows = this.additionalMembers.length;
      });
    },
    triggerFetchOptions(search: string, loading: (value: boolean) => void) {
      this.searchString = search;
      clearTimeout(this.queryTimer);
      if (search.length < 3) {
        this.queriedUsers = [];
        return;
      }
      this.queryTimer = window.setTimeout(
        () => this.fetchUserOptions(search, loading),
        1000
      );
    },
    async fetchUserOptions(search: string, loading: (value: boolean) => void) {
      if (search != "") {
        loading(true);
        await UserApi.queryUsers(
          search,
          this.parentId,
          (response: any) => {
            this.queriedUsers = [];
            for (const datum of response.data) {
              this.queriedUsers.push(datum);
            }
            loading(false);
          },
          () => {
            loading(false);
          }
        );
        if (this.validateEmail() && this.queriedUsers.length == 0) {
          // Add unknown entry as an entry to the list (email address of user to invite)
          const obj = {
            displayName: this.searchString,
            emailAddress: this.searchString,
            hasProjectRole: false,
          };
          this.queriedUsers.push(obj);
          loading(false);
        }
      }
    },
    getProjectRoles() {
      this.isBusy = true;
      ProjectRoleApi.getProjectRoles(this.parentId, (response: any) => {
        this.projectRoles = [];

        this.ownerCount = 0;
        for (const datum of response.data) {
          if (datum.role.displayName === "Owner") {
            this.ownerCount++;
          }
        }

        for (const datum of response.data) {
          datum.firstName = datum.user.givenname;
          datum.lastName = datum.user.surname;
          datum.displayName = datum.user.displayName;
          datum.emailAddress = datum.user.emailAddress;
          datum.roleName = datum.role.displayName;
          datum.enabledControls =
            datum.role.displayName !== "Owner" || this.ownerCount > 1;
          this.projectRoles.push(datum);
        }
        this.isBusy = false;
        this.filteredRows = this.projectRoles.length;
      });
    },
    setRole(projectRole: {
      projectId: string;
      user: {
        id: string;
        displayName: string;
        givenname: string;
        surname: string;
        emailAddress: string;
      };
      role: { id: string; displayName: string };
    }) {
      projectRole.projectId = this.parentId;
      projectRole.role.displayName =
        projectRole.role.displayName === "Member" ? "Owner" : "Member";
      let text = "";
      if (LanguageUtil.getLanguage() === "de") {
        text =
          this.$t("changedRole1") +
          projectRole.user.displayName +
          this.$t("changedRole2") +
          this.getRoleNameFromId(projectRole.role.id) +
          this.$t("changedRole3") +
          this.projectName;
      } else {
        text =
          this.$t("changedRole1") +
          projectRole.user.displayName +
          this.$t("changedRole2") +
          this.projectName +
          this.$t("changedRole3") +
          projectRole.role.displayName;
      }
      ProjectRoleApi.setProjectRole(projectRole, () => {
        this.makeToast(text, this.$t("userManagement").toString());
        if (projectRole.role.displayName === "Owner") {
          this.ownerCount++;
        } else {
          this.ownerCount--;
        }
        if (this.ownerCount <= 2) {
          for (const currentProjectRole of this.projectRoles) {
            this.$set(
              currentProjectRole,
              "enabledControls",
              (currentProjectRole as any).role.displayName !== "Owner" ||
                this.ownerCount > 1
            );
          }
        }
      });
    },
    getRoleNameFromId(roleId: string) {
      for (const role of this.roles) {
        if ((role as any).value === roleId) {
          return (role as any).text;
        }
      }
    },
    importUser() {
      this.selectedProject = null;
      for (const projectRole of this.additionalMembers) {
        (projectRole as any).projectId = this.parentId;
        this.addUser(projectRole as any);
      }
      this.$bvModal.hide("importUserModal");
      this.additionalMembers = [];
    },
    inviteUser() {
      const param = {
        projectId: this.candidateForInvitation.projectId,
        role: this.candidateForInvitation.role.id,
        email: this.candidateForInvitation.user.emailAddress,
      };
      const text = this.$t("invitedUserText", {
        email: this.candidateForInvitation.user.emailAddress,
        role: this.candidateForInvitation.role.displayName,
        projectName: this.projectName,
      }).toString();
      const errorText =
        this.$t("invitedUserError1") +
        this.candidateForInvitation.user.emailAddress +
        this.$t("invitedUserError2");
      this.storeNewInvitation(param, text, errorText);
      this.$bvModal.hide("inviteUserModal");
    },
    addUser(projectRole: {
      projectId: string;
      user: {
        id: string;
        displayName: string;
        givenname: string;
        surname: string;
        emailAddress: string;
      };
      role: { id: string; displayName: string };
    }) {
      this.selectionIsValid = false;
      this.searchString = "";
      projectRole.projectId = this.parentId;
      let text = "";
      if (LanguageUtil.getLanguage() === "de") {
        text =
          this.$t("addedUser1") +
          projectRole.user.displayName +
          this.$t("addedUser2") +
          this.getRoleNameFromId(projectRole.role.id) +
          this.$t("addedUser3") +
          this.projectName +
          this.$t("addedUser4");
      } else {
        text =
          this.$t("addedUser1") +
          projectRole.user.displayName +
          this.$t("addedUser2") +
          this.projectName +
          this.$t("addedUser3") +
          this.getRoleNameFromId(projectRole.role.id) +
          this.$t("addedUser4");
      }
      ProjectRoleApi.setProjectRole(projectRole, () => {
        this.getProjectRoles();
        this.makeToast(text, this.$t("userManagement").toString());
        this.queriedUsers = [];
        this.newUserRole.user.id = "";
      });
    },
    prepareInvitation(projectRole: {
      projectId: string;
      user: {
        id: string;
        displayName: string;
        givenname: string;
        surname: string;
        emailAddress: string;
      };
      role: { id: string; displayName: string };
    }) {
      this.isUserInvited = false;
      this.isInvitationExpired = false;
      this.candidateForInvitation = projectRole;
      for (const externalUser of this.externalUsers) {
        if (
          externalUser.userMail.toLowerCase() ===
          this.candidateForInvitation.user.displayName.toLowerCase()
        ) {
          this.isUserInvited = true;
          const today = new Date();
          const expirationDate = new Date(externalUser.expiration);
          if (expirationDate <= today) {
            this.isInvitationExpired = true;
          }
          break;
        }
      }
      if (this.isUserInvited && !this.isInvitationExpired) {
        this.$bvModal.show("invitationPendingModal");
      } else {
        this.$bvModal.show("inviteUserModal");
      }
    },
    prepareDeletion(projectRole: {
      projectId: string;
      user: {
        id: string;
        displayName: string;
        givenname: string;
        surname: string;
        emailAddress: string;
      };
      role: { id: string; displayName: string };
    }) {
      this.candidateForDeletion = projectRole;
      this.isDeleteUserModalVisible = true;
    },
    deleteUser() {
      const text =
        this.$t("removedUser1") +
        this.candidateForDeletion.user.displayName +
        this.$t("removedUser2") +
        this.projectName +
        this.$t("removedUser3");
      ProjectRoleApi.deleteUser(
        this.candidateForDeletion.projectId,
        this.candidateForDeletion.user.id,
        this.candidateForDeletion.role.id,
        () => {
          this.getProjectRoles();
          this.makeToast(text, this.$t("userManagement").toString());
        }
      );
      this.isDeleteUserModalVisible = false;
    },
    closeUserModal() {
      this.isDeleteUserModalVisible = false;
    },
    removeSelectedRow(projectRole: any) {
      const index = this.additionalMembers.indexOf(projectRole);
      this.additionalMembers.splice(index, 1);
    },
    filterMock(option: unknown, label: string, search: string) {
      return search.length > 0;
    },
    onFiltered(filteredItems: []) {
      this.filteredRows = filteredItems.length;
    },
    onFilteredRows(value: number) {
      this.filteredRows = value;
    },
    makeToast(text = "Message", givenTitle = "Title", toastVariant = "") {
      this.$bvToast.toast(text, {
        title: givenTitle,
        autoHideDelay: 5000,
        variant: toastVariant,
        toaster: "b-toaster-bottom-right",
        noCloseButton: true,
      });
    },
  },
});
</script>

<style>
.UserManagement .adaptSelect .vs__dropdown-toggle {
  height: calc(1.4em + 0.75rem + 2px) !important;
}
.UserManagement .adaptAlign #firstCol {
  padding-right: 4px;
  padding-left: 15px;
}
.UserManagement .adaptAlign #secondCol {
  padding-right: 4px;
  padding-left: 0px;
}
.UserManagement .adaptAlign #thirdCol {
  padding-right: 4px;
  padding-left: 0px;
  text-align: left;
  margin-top: 0px;
}
.UserManagement .adaptAlign #thirdCol .btn {
  margin: 0px;
  margin-right: 4px;
}
.UserManagement .adaptAlign #forthCol {
  padding-right: 4px;
  padding-left: 0px;
  text-align: left;
}
.UserManagement .adaptAlign .col-sm-5 .no-results .vs__actions {
  display: none;
}
</style>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.leftActionBtn {
  margin: 0px 2px 0px 0px;
}
.leftActionBtn:hover,
.leftActionBtn:active,
.leftActionBtn:focus {
  background-color: #cc071e;
  border-color: #8e0515;
  color: #ffffff;
}
.rightActionBtn {
  margin: 0px 0px 0px 2px;
}
.inviteModalLeftBtn {
  float: right;
  margin-right: 0.5rem !important;
}
.inviteModalRightBtn {
  float: right;
}
</style>
